
#include "global.h"


/*
 * Two global variables to count properties discovered by the backtrack routine
 * during its execution.  The "checks" variable maintains the number of
 * consistency checks performed by the "backtrack" routine.  The "count"
 * variable maintains the number of solutions found by the backtrack routine.
 */
unsigned int checks, count;


/*
 *  Interface to backtracking routines.  The backtracking method used
 *  is determined by ``method''.
 */
void
solve( method, C, n, k, solution, number, found )
	int (* method)(), n, k, number, *found;
	NETWORK C;
	SOLUTION solution;
{
	checks = 0;
	count = 0;
	method(C, n, k, solution, 1, number, found);
}

